<?php
/*
Copyright (C) 2004  Gregory Morris

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

Class ImageGallery{

  // Class Variables
  var $TblImages;
  var $TblGalleries;
  var $TblImageComments;

  var $DefaultImageWidth;
  var $DefaultThumbWidth;  

  /* Database Structure
     --tblImages--
     id       : int(11)
     name     : varchar(255)
     filename : varchar(255)
     caption  : text
     image    : blob   -- this is base64 encoded before it goes in to database
                       -- and is base64 decoded when it is selected
     gallery  : int(3)

     --tblGalleries--
     id          : int(3)
     name        : varchar(255)
     description : text
  */

  function ImageGallery($dbhost, $dbname, $dbuser, $dbpass,
                        $tblImages='tblImages',
                        $tblGalleries='tblGalleries',
			$tblImageComments='tblImageComments'
                        )
  {
    $this->TblImages    = $tblImages;
    $this->TblGalleries = $tblGalleries;
    $this->TblImageComments = $tblImageComments;

    $dbconn = mysql_connect ($dbhost,$dbuser,$dbpass) or die('Unable to connect to database!');
    mysql_select_db($dbname,$dbconn) or die('Unable to select database!');

    $this->DefaultImageWidth=500;
    $this->DefaultThumbWidth=20;
  }

  function setDefaultImageWidth($width){
    $this->DefaultImageWidth=$width;
  }

  function setDefaultThumbWidth($width){
    $this->DefaultThumbWidth=$width;
  }


  ////////////////////////////////////////////////////////////
  // insertImage() -- inserts an image into the database
  //                  also creates a thumbnail for jpeg images
  //
  // $tmpName   : $HTTP_POST_FILES['formVariable']['tmp_name']
  // $name      : the name of the picture
  // $filename  : $HTTP_POST_FILES['formVariable']['name']
  // $caption   : the caption associated with the picture
  // $galleryID : the id of gallery the picture is in
  //
  // returns    : the new id of the image
  ////////////////////////////////////////////////////////////
  function insertImage($tmpName, $name, $filename, $caption, $galleryID, $thumbTmpName=''){
    if( 
       !(substr($filename, -4) == '.jpg' 
     or  substr($filename, -4) == '.JPG'
     or  substr($filename, -5) == '.jpeg'
     or  substr($filename, -4) == '.GIF'
     or  substr($filename, -4) == '.gif')){
      return 0;
    }

    $size = GetImageSize($tmpName);
/*
    //create a thumbnail
    if($size[2] == 2){
        $src = ImageCreateFromJPEG($tmpname);
        if($size[0] <= $this->DefaultThumbWidth){
          $tWidth = $size[0];
          $tHeight = $size[1];
        }else{
          $tWidth  = $this->DefaultThumbWidth;
          $tHeight = ($tWidth*$size[1])/$size[0];
        }
        $dest = ImageCreate($tWidth,$tHeight);
        
        imagecopyresized($dest, $src, 0, 0, 0, 0, $tWidth, $tHeight, $size[0], $size[1]);
	imageJPEG($dest, "_thumb.jpg");
        ImageDestroy($src);
        ImageDestroy($dest);
    }
*/
    // read in file
    $fp = fopen($tmpName,"r");
    $file = fread($fp,filesize($tmpName));
    $bfile  = base64_encode($file);
    fclose($fp);

    // read in thumb
    if('' != $thumbTmpName){
      $fp = fopen($thumbTmpName,"r");
      $file = fread($fp,filesize($tmpName));
      $tfile = base64_encode($file);
      fclose($fp);
    }

/*
    if(file_exists("_thumb.jpg")){
      // read in thumb file
      $tfp = fopen("_thumb.jpg","r");
      $tfile = fread($tfp,filesize("_thumb.jpg"));
      $btfile = base64_encode($tfile);
    }
*/
    // insert file and filename into database
    $query =<<<_QUERY
        INSERT {$this->TblImages}
        SET image='{$bfile}',
	    width='{$size[0]}',
	    height='{$size[1]}',
            name='{$name}',
            filename='{$filename}',
            caption='{$caption}',
            gallery='{$galleryID}',
	    thumb='{$tfile}'
_QUERY;
    $result = mysql_query($query);

//echo $query;

    // delete temp file
//    unlink($tmpName);
/*
    unlink("_thumb.jpg");
*/
    $insId = mysql_insert_id();
    if($insID>0)
      return $insID;
    else
      return 0;
  }


  ////////////////////////////////////////////////////////////
  // updateImage() -- updates an image with new values
  //
  // $imageID     : the id of the image
  // $name        : the name of the image
  // $caption	  : the caption for the image
  // $galleryID   : the id of the gallery
  //
  // returns      : 1 if successful, or 0 on error
  ////////////////////////////////////////////////////////////
  function updateImage($imageID,$name,$caption,$galleryID){

      $query = <<<_QUERY
        UPDATE {$this->TblImages} 
	SET 
		gallery={$galleryID},
		name='{$name}',
		caption='{$caption}'
	WHERE 
		id={$imageID}
_QUERY;
    $result = mysql_query($query);

    if($result)
      return 1;
    else
      return 0;
  }

  ////////////////////////////////////////////////////////////
  // createGallery() -- creates a new image gallery
  //
  // $name        : the name of the gallery
  // $description : the description of the gallery
  //
  // returns      : the new id of the gallery, or 0 on error
  ////////////////////////////////////////////////////////////
  function createGallery($name,$description){
    $query =<<<_QUERY
        INSERT {$this->TblGalleries}
        SET name='{$name}',
            description='{$description}'
_QUERY;
    $result = mysql_query($query);

    if($result)
      return mysql_insert_id();
    else
      return 0;
  }

  ////////////////////////////////////////////////////////////
  // getImage -- gets an image from the database
  //
  // $imageID : is the id of the image you wish to get
  //
  // returns  : an object containing name, filename, caption, 
  // 		and image,
  //            or 0 on error
  ////////////////////////////////////////////////////////////
  function getImage($imageID){
    $query =<<<_QUERY
        SELECT name, filename, caption, image, width, height, gallery, thumb
        FROM {$this->TblImages}
        WHERE id={$imageID}
_QUERY;
    $result = mysql_query($query);
    if(@mysql_num_rows($result)){
      $row = mysql_fetch_object($result);
      $row->image = base64_decode($row->image);
      $row->thumb = base64_decode($row->thumb);
      return $row;
    } else
      return 0;
  }

  ////////////////////////////////////////////////////////////
  // getImageList -- gets a list of images from the database
  //
  // $galleryID : is the id of the gallery you wish to list
  //
  // returns    : an associative array containing the ids and
  //              image names/captions/thumbnails associated with that id,
  //              or 0 on error
  ////////////////////////////////////////////////////////////
  function getImageList($galleryID){
    $query =<<<_QUERY
        SELECT id, name, caption, thumb, filename
        FROM {$this->TblImages}
        WHERE gallery={$galleryID}
	ORDER BY orderby
_QUERY;
    $result = mysql_query($query);
    if(@mysql_num_rows($result)){
      while($row = mysql_fetch_object($result)){
        $aImages[$row->id] = array($row->name,$row->caption,$row->thumb,$row->filename);
      }
      return $aImages;
    } else
      return 0;
  }

  ////////////////////////////////////////////////////////////
  // getGalleryList -- gets a list of galleries from the database
  //
  // returns    : an associative array containing the ids and an
  //              array of gallery names and descriptions
  //              associated with that id,
  //              or 0 on error
  ////////////////////////////////////////////////////////////
  function getGalleryList(){
    $query =<<<_QUERY
        SELECT id, name, description
        FROM {$this->TblGalleries}
	ORDER BY id DESC
_QUERY;
    $result = mysql_query($query);
    if(@mysql_num_rows($result)){
      while($row = mysql_fetch_object($result)){
        $aGalleries[$row->id] = array($row->name,$row->description);
      }
      return $aGalleries;
    } else
      return 0;
  }

  ////////////////////////////////////////////////////////////
  // displayImage() - displays an image
  //
  // $imageObject : an object of the same structure as
  //                returned by getImage() 
  //
  ////////////////////////////////////////////////////////////
  function displayImage($imageObject){
      $file = $imageObject->filename;

      if(substr($file, -4) == '.jpg' or substr($file, -5) == '.jpeg' or substr($file,-4) == '.JPG')
      {
        header ("Content-Type: image/jpeg");
        echo $imageObject->image;
        echo '<p>'.$imageObject.name.'<br>'.
             $imageObject.caption.'</p>';
      }
      elseif(substr($file, -4) == '.gif')
      {
        header ("Content-Type: image/gif");
        echo $imageObject->image;
        echo '<p>'.$imageObject.name.'<br>'.
             $imageObject.caption.'</p>';
      }
  }


  //$imageObject={name, filename, caption, image, thumb}
  function writeImage($imageObject,$blnThumb=false){
//echo "WRITE IMAGE";
//print_R($imageObject);
    if($blnThumb) {
      $file = 'thumbs/t-'.$imageObject->filename;
      $image = $imageObject->thumb;
    } else {
      $file = 'images/'.$imageObject->filename;
      $image = $imageObject->image;
    }

    $fp = fopen($file,'w');
    fwrite($fp,$image);
    fclose($fp);
  }

  //$imageObject={name, filename, caption, image}
  function unwriteImage($imageObject){
    if(file_exists('images/'.$imageObject->filename)){
      unlink('images/'.$imageObject->filename);
    }
  }


  ////////////////////////////////////////////////////////////
  // deleteImage() - deletes an image
  //
  // $imageID : id of image to delete
  //
  ////////////////////////////////////////////////////////////
  function deleteImage($imageID){
    $query = <<<_QUERY
      DELETE FROM {$this->TblImages} WHERE id={$imageID}
_QUERY;
    $result = mysql_query($query);

    return 0;
  }

  ////////////////////////////////////////////////////////////
  // deleteGallery() - deletes an image
  //
  // $galleryID : id of gallery to delete
  // $newGalID  : id of gallery to set all images from deleted
  //              gallery to
  //
  ////////////////////////////////////////////////////////////
  function deleteGallery($galleryID, $newGalID){

    if($newGalID==-1){
      $query = <<<_QUERY
	DELETE FROM {$this->TblImages} WHERE gallery={$galleryID}
_QUERY;
    } else {
      $query = <<<_QUERY
	UPDATE {$this->TblImages} SET gallery={$newGalID}
		WHERE gallery={$galleryID}
_QUERY;
    }
    $result = mysql_query($query);
    if(!$result)
      return 0;

    unset($result);

    $query = <<<_QUERY
      DELETE FROM {$this->TblGalleries} WHERE id={$galleryID}
_QUERY;
    $result = mysql_query($query);
    if(!$result)
      return 0;
    else
      return $newGalID;
  }

  ////////////////////////////////////////////////////////////
  // getGalleryName() - gets the name of the gallery
  //
  // $galleryID : id of gallery
  //
  ////////////////////////////////////////////////////////////
  function getGalleryName($galleryID){
    $query = <<<_QUERY
      SELECT name FROM {$this->TblGalleries} WHERE id=$galleryID
_QUERY;
    $result = mysql_query($query);
    $row = mysql_fetch_object($result);
    return $row->name;
  }


  function getScaledImageWidth($image){
    if($image->width <= $this->DefaultImageWidth)
      return $image->width;
    else
      return $this->DefaultImageWidth;
  }

  function getScaledImageHeight($image){
    return 
	($image->height*$this->getScaledImageWidth($image))/$image->width;
  }

  function getGalleryImages($galleryID){
    $query = <<<_QUERY
	SELECT name,id FROM {$this->TblImages} WHERE gallery={$galleryID}
	ORDER BY orderby,id
_QUERY;
    $result = mysql_query($query);
    while($row = mysql_fetch_object($result)){
      $imgArray[] = $row->id;
    }
    return $imgArray;
  }

  function getNextPrev($galleryID,$imageID){
    $galleryImages = $this->getGalleryImages($galleryID);
    $numImages = count($galleryImages);
    $currImage = array_search($imageID,$galleryImages);
    $nextImage = $galleryImages[$currImage+1];
    $prevImage = $galleryImages[$currImage-1];
    return array('num'=>$numImages,
	 	 'prev'=>$prevImage,
		 'curr'=>$imageID,
		 'currpos'=>$currImage,
		 'next'=>$nextImage);
  }


  function addComment($imageID, $author, $authorEmail,
                      $authorIP, $commentSubject,$comment){

    if($imageID=='' || $author=='' || $commentSubject=='' || $comment==''){
      return 0;
    }

    $comment=mysql_escape_string($comment);
    $commentSubject=mysql_escape_string($commentSubject);
    $author=mysql_escape_string($author);

    $query = <<<_QUERY
        INSERT {$this->TblImageComments}
        SET 
		idImage='{$imageID}',
		comment='{$comment}',
		commentSubject='{$commentSubject}',
		author='{$author}',
		authorEmail='{$authorEmail}',
		authorIP='{$authorIP}'
_QUERY;
    return mysql_query($query);
  }

  function getCommentList($imageID='',$orderby='id',$extrawhere=''){
    $where = '';
    if($imageID=='')
      $where = " 1=1 ";
    else
      $where = " idImage='".$imageID."' ";

    if($extrawhere != '') $where .= ' AND '.$extrawhere;
    $orderby = ' ORDER BY '.$orderby;

    $where .= " AND (comment!='' AND commentSubject!='' AND author!='')";

    $query=<<<_END
	SELECT *,
		UNIX_TIMESTAMP(commentTime) as unix_time
	FROM {$this->TblImageComments} 
	WHERE
	{$where}
	{$orderby}
_END;

//echo $query;

    $result = mysql_query($query);
    if($result){
      while($row=mysql_fetch_object($result)){
        $aList[$row->id] = $row;
      }
      return $aList;
    } else {
      return 0;
    }
  }

}
?>